# coding: utf-8

"""
    IBM CLOUD PAK FOR DATA

    This is the Public API for IBM Cloud Pak for Data  # noqa: E501

    OpenAPI spec version: Beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from icpd_core.api_client import ApiClient


class CacheApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_all_replicas_caches_v1(self, cache_type, cache_key, **kwargs):  # noqa: E501
        """Delete caches API  # noqa: E501

        This API deletes caches in all replicas of zen-core-api provided the cache type and cache key  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_all_replicas_caches_v1(cache_type, cache_key, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cache_type: Type of the cache that gets deleted as a result of this API (required)
        :param str cache_key: Key of the cache that gets deleted as a result of this API (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :param bool seq: If seq is set to true, clears cache sequentially from each replica; otherwise, concurrently
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_all_replicas_caches_v1_with_http_info(cache_type, cache_key, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_all_replicas_caches_v1_with_http_info(cache_type, cache_key, **kwargs)  # noqa: E501
            return data

    def delete_all_replicas_caches_v1_with_http_info(self, cache_type, cache_key, **kwargs):  # noqa: E501
        """Delete caches API  # noqa: E501

        This API deletes caches in all replicas of zen-core-api provided the cache type and cache key  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_all_replicas_caches_v1_with_http_info(cache_type, cache_key, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cache_type: Type of the cache that gets deleted as a result of this API (required)
        :param str cache_key: Key of the cache that gets deleted as a result of this API (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :param bool seq: If seq is set to true, clears cache sequentially from each replica; otherwise, concurrently
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cache_type', 'cache_key', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id', 'seq']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_all_replicas_caches_v1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cache_type' is set
        if ('cache_type' not in params or
                params['cache_type'] is None):
            raise ValueError("Missing the required parameter `cache_type` when calling `delete_all_replicas_caches_v1`")  # noqa: E501
        # verify the required parameter 'cache_key' is set
        if ('cache_key' not in params or
                params['cache_key'] is None):
            raise ValueError("Missing the required parameter `cache_key` when calling `delete_all_replicas_caches_v1`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'cache_type' in params:
            query_params.append(('cache_type', params['cache_type']))  # noqa: E501
        if 'cache_key' in params:
            query_params.append(('cache_key', params['cache_key']))  # noqa: E501
        if 'seq' in params:
            query_params.append(('seq', params['seq']))  # noqa: E501

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/caches', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_cache_v1(self, cache_type, cache_key, **kwargs):  # noqa: E501
        """Delete cache API  # noqa: E501

        This API deletes cache for specified cache type and cache key  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_cache_v1(cache_type, cache_key, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cache_type: Type of the cache that gets deleted as a result of this API (required)
        :param str cache_key: Key of the cache that gets deleted as a result of this API (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_cache_v1_with_http_info(cache_type, cache_key, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_cache_v1_with_http_info(cache_type, cache_key, **kwargs)  # noqa: E501
            return data

    def delete_cache_v1_with_http_info(self, cache_type, cache_key, **kwargs):  # noqa: E501
        """Delete cache API  # noqa: E501

        This API deletes cache for specified cache type and cache key  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_cache_v1_with_http_info(cache_type, cache_key, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cache_type: Type of the cache that gets deleted as a result of this API (required)
        :param str cache_key: Key of the cache that gets deleted as a result of this API (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cache_type', 'cache_key', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_cache_v1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cache_type' is set
        if ('cache_type' not in params or
                params['cache_type'] is None):
            raise ValueError("Missing the required parameter `cache_type` when calling `delete_cache_v1`")  # noqa: E501
        # verify the required parameter 'cache_key' is set
        if ('cache_key' not in params or
                params['cache_key'] is None):
            raise ValueError("Missing the required parameter `cache_key` when calling `delete_cache_v1`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cache_type' in params:
            path_params['cache_type'] = params['cache_type']  # noqa: E501
        if 'cache_key' in params:
            path_params['cache_key'] = params['cache_key']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/caches/{cache_type}/{cache_key}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cache_metadata_by_type_v1(self, cache_type, **kwargs):  # noqa: E501
        """Get cache metadata for specified cache type  # noqa: E501

        This API returns cache metadata for specified cache type  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cache_metadata_by_type_v1(cache_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cache_type: cache type (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: GetCacheMetadataByTypeResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cache_metadata_by_type_v1_with_http_info(cache_type, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cache_metadata_by_type_v1_with_http_info(cache_type, **kwargs)  # noqa: E501
            return data

    def get_cache_metadata_by_type_v1_with_http_info(self, cache_type, **kwargs):  # noqa: E501
        """Get cache metadata for specified cache type  # noqa: E501

        This API returns cache metadata for specified cache type  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cache_metadata_by_type_v1_with_http_info(cache_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cache_type: cache type (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: GetCacheMetadataByTypeResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cache_type', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cache_metadata_by_type_v1" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cache_type' is set
        if ('cache_type' not in params or
                params['cache_type'] is None):
            raise ValueError("Missing the required parameter `cache_type` when calling `get_cache_metadata_by_type_v1`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cache_type' in params:
            path_params['cache_type'] = params['cache_type']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/caches/{cache_type}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetCacheMetadataByTypeResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
