# coding: utf-8

"""
    IBM CLOUD PAK FOR DATA

    This is the Public API for IBM Cloud Pak for Data  # noqa: E501

    OpenAPI spec version: Beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from icpd_core.api_client import ApiClient


class DataplanesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_dataplane(self, dataplane_name, **kwargs):  # noqa: E501
        """Delete a dataplane  # noqa: E501

        Delete a dataplane by name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_dataplane(dataplane_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataplane_name: Name of the dataplane (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: InstanceResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_dataplane_with_http_info(dataplane_name, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_dataplane_with_http_info(dataplane_name, **kwargs)  # noqa: E501
            return data

    def delete_dataplane_with_http_info(self, dataplane_name, **kwargs):  # noqa: E501
        """Delete a dataplane  # noqa: E501

        Delete a dataplane by name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_dataplane_with_http_info(dataplane_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataplane_name: Name of the dataplane (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: InstanceResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataplane_name', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_dataplane" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataplane_name' is set
        if ('dataplane_name' not in params or
                params['dataplane_name'] is None):
            raise ValueError("Missing the required parameter `dataplane_name` when calling `delete_dataplane`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dataplane_name' in params:
            path_params['dataplane_name'] = params['dataplane_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/dataplanes/{dataplane_name}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InstanceResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dataplane_details(self, dataplane_name, **kwargs):  # noqa: E501
        """Retrieve details of a specific dataplane  # noqa: E501

        Retrieve details of dataplane by its name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dataplane_details(dataplane_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataplane_name: Name of the dataplane (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: DataplaneOrgMetadata
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dataplane_details_with_http_info(dataplane_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dataplane_details_with_http_info(dataplane_name, **kwargs)  # noqa: E501
            return data

    def get_dataplane_details_with_http_info(self, dataplane_name, **kwargs):  # noqa: E501
        """Retrieve details of a specific dataplane  # noqa: E501

        Retrieve details of dataplane by its name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dataplane_details_with_http_info(dataplane_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataplane_name: Name of the dataplane (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: DataplaneOrgMetadata
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataplane_name', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dataplane_details" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataplane_name' is set
        if ('dataplane_name' not in params or
                params['dataplane_name'] is None):
            raise ValueError("Missing the required parameter `dataplane_name` when calling `get_dataplane_details`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'dataplane_name' in params:
            path_params['dataplane_name'] = params['dataplane_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/dataplanes/{dataplane_name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DataplaneOrgMetadata',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dataplanes(self, **kwargs):  # noqa: E501
        """Get a list of all dataplanes  # noqa: E501

        Retrieve the list of all dataplanes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dataplanes(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :param int offset: The number of dataplane records to skip before starting to collect the result set.
        :param int limit: The number of dataplane records to return.
        :param str sort: sort by the field e.g. sort=dataplane_name or sort=-dataplane_name for descending,\\n supported keys are dataplane_name, created_by, updated_at
        :return: GetAllDataplanesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dataplanes_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_dataplanes_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_dataplanes_with_http_info(self, **kwargs):  # noqa: E501
        """Get a list of all dataplanes  # noqa: E501

        Retrieve the list of all dataplanes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dataplanes_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :param int offset: The number of dataplane records to skip before starting to collect the result set.
        :param int limit: The number of dataplane records to return.
        :param str sort: sort by the field e.g. sort=dataplane_name or sort=-dataplane_name for descending,\\n supported keys are dataplane_name, created_by, updated_at
        :return: GetAllDataplanesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id', 'offset', 'limit', 'sort']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dataplanes" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/dataplanes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetAllDataplanesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def patch_dataplane_phy_location(self, body, **kwargs):  # noqa: E501
        """assign a dataplane to a physical location  # noqa: E501

        assign a dataplane to a physical location by dataplane id and physical location id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_dataplane_phy_location(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewDataplanePhyLocationMetadata body: dataplane physical location metadata (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessResponseV3
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_dataplane_phy_location_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_dataplane_phy_location_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def patch_dataplane_phy_location_with_http_info(self, body, **kwargs):  # noqa: E501
        """assign a dataplane to a physical location  # noqa: E501

        assign a dataplane to a physical location by dataplane id and physical location id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_dataplane_phy_location_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewDataplanePhyLocationMetadata body: dataplane physical location metadata (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessResponseV3
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_dataplane_phy_location" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_dataplane_phy_location`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/dataplanes_physical_locations', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponseV3',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def patch_orgs_dataplanes(self, body, **kwargs):  # noqa: E501
        """Assign a dataplane to an organization  # noqa: E501

        Assign a dataplane to an organization by dataplane name and organization name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_orgs_dataplanes(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewOrgDataplaneMetadata body: Dataplane organization metadata (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessResponseV3
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_orgs_dataplanes_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_orgs_dataplanes_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def patch_orgs_dataplanes_with_http_info(self, body, **kwargs):  # noqa: E501
        """Assign a dataplane to an organization  # noqa: E501

        Assign a dataplane to an organization by dataplane name and organization name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_orgs_dataplanes_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewOrgDataplaneMetadata body: Dataplane organization metadata (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessResponseV3
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_orgs_dataplanes" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_orgs_dataplanes`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/orgs_dataplanes', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponseV3',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_dataplane(self, body, **kwargs):  # noqa: E501
        """Create a dataplane  # noqa: E501

        Create a dataplane by name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_dataplane(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewDataplaneMetadata body: Dataplane metadata (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_dataplane_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_dataplane_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_dataplane_with_http_info(self, body, **kwargs):  # noqa: E501
        """Create a dataplane  # noqa: E501

        Create a dataplane by name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_dataplane_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NewDataplaneMetadata body: Dataplane metadata (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :return: SuccessPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'jwt_auth_user_payload', 'authorization', 'ibm_cpd_transaction_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_dataplane" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_dataplane`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/dataplanes', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessPostResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
