# coding: utf-8

"""
    IBM CLOUD PAK FOR DATA

    This is the Public API for IBM Cloud Pak for Data  # noqa: E501

    OpenAPI spec version: Beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from icpd_core.api_client import ApiClient


class EdgeServiceProviderApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_edge_service_instance(self, body, **kwargs):  # noqa: E501
        """De-provision service instance on micro edge  # noqa: E501

        This api de-provisions the service instance running on the edge  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_edge_service_instance(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServiceInstanceMetadata body: information about the service instance that needs to be de-provisioned (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :param bool purge: Set to true to force delete provisioned service instances
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_edge_service_instance_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_edge_service_instance_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def delete_edge_service_instance_with_http_info(self, body, **kwargs):  # noqa: E501
        """De-provision service instance on micro edge  # noqa: E501

        This api de-provisions the service instance running on the edge  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_edge_service_instance_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServiceInstanceMetadata body: information about the service instance that needs to be de-provisioned (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :param bool purge: Set to true to force delete provisioned service instances
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'jwt_auth_user_payload', 'authorization', 'purge']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_edge_service_instance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `delete_edge_service_instance`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'purge' in params:
            query_params.append(('purge', params['purge']))  # noqa: E501

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_instances/provision', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def download_custom_metrics(self, **kwargs):  # noqa: E501
        """Download custom metrics file from the bedrock  # noqa: E501

        this api retrieves the custom metrics file  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_custom_metrics(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.download_custom_metrics_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.download_custom_metrics_with_http_info(**kwargs)  # noqa: E501
            return data

    def download_custom_metrics_with_http_info(self, **kwargs):  # noqa: E501
        """Download custom metrics file from the bedrock  # noqa: E501

        this api retrieves the custom metrics file  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_custom_metrics_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method download_custom_metrics" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/octet-stream'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_instances/custom_metrics', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def download_instance_log(self, instance_name, **kwargs):  # noqa: E501
        """Download instance log file from the bedrock  # noqa: E501

        this api retrieves the log file for the application  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_instance_log(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: instance id of the application deployed on the edge (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.download_instance_log_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.download_instance_log_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def download_instance_log_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Download instance log file from the bedrock  # noqa: E501

        this api retrieves the log file for the application  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_instance_log_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: instance id of the application deployed on the edge (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method download_instance_log" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `download_instance_log`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/octet-stream'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_instances/log/{instance_name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_edge_instance_status(self, instance_id, **kwargs):  # noqa: E501
        """get status of an edge application deployed on the edge  # noqa: E501

        this api returns the status of a given edge application  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_edge_instance_status(instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_id: instance id of the application deployed on the edge (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessGetStatusResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_edge_instance_status_with_http_info(instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_edge_instance_status_with_http_info(instance_id, **kwargs)  # noqa: E501
            return data

    def get_edge_instance_status_with_http_info(self, instance_id, **kwargs):  # noqa: E501
        """get status of an edge application deployed on the edge  # noqa: E501

        this api returns the status of a given edge application  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_edge_instance_status_with_http_info(instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_id: instance id of the application deployed on the edge (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessGetStatusResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_id', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_edge_instance_status" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_id' is set
        if ('instance_id' not in params or
                params['instance_id'] is None):
            raise ValueError("Missing the required parameter `instance_id` when calling `get_edge_instance_status`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_id' in params:
            path_params['instance_id'] = params['instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_instances/status/{instance_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessGetStatusResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_edge_metrics(self, **kwargs):  # noqa: E501
        """Get metrics from an edge system  # noqa: E501

        this api retrieves CPU and Memory usage for instances provisioned.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_edge_metrics(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessGetContainerMetricsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_edge_metrics_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_edge_metrics_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_edge_metrics_with_http_info(self, **kwargs):  # noqa: E501
        """Get metrics from an edge system  # noqa: E501

        this api retrieves CPU and Memory usage for instances provisioned.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_edge_metrics_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessGetContainerMetricsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_edge_metrics" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_instances/metrics', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessGetContainerMetricsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def patch_edge_service_instance(self, body, **kwargs):  # noqa: E501
        """Restart service instance on micro edge  # noqa: E501

        This api restarts the service instance running on the edge  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_edge_service_instance(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServiceInstanceMetadata body: information about the service instance that needs to be restarted (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_edge_service_instance_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_edge_service_instance_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def patch_edge_service_instance_with_http_info(self, body, **kwargs):  # noqa: E501
        """Restart service instance on micro edge  # noqa: E501

        This api restarts the service instance running on the edge  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_edge_service_instance_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServiceInstanceMetadata body: information about the service instance that needs to be restarted (required)
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_edge_service_instance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_edge_service_instance`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_instances/provision', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_edge_service_instance(self, body, **kwargs):  # noqa: E501
        """Provision a new Service Instance on micro edge  # noqa: E501

        this api provisions a new service instance in an edge node of Cloud Pak for Data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_edge_service_instance(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServiceInstanceMetadata body: information about the service instance that needs to be provisioned (required)
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :param str ibm_cpd_callback_token: Callback token for the service provider
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_edge_service_instance_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_edge_service_instance_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_edge_service_instance_with_http_info(self, body, **kwargs):  # noqa: E501
        """Provision a new Service Instance on micro edge  # noqa: E501

        this api provisions a new service instance in an edge node of Cloud Pak for Data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_edge_service_instance_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServiceInstanceMetadata body: information about the service instance that needs to be provisioned (required)
        :param str ibm_cpd_transaction_id: Unique ID that is used to identify each transaction.
        :param str ibm_cpd_callback_token: Callback token for the service provider
        :param str jwt_auth_user_payload: Added by zen-core-api to identify the current user that triggered the request
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services
        :return: SuccessPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'ibm_cpd_transaction_id', 'ibm_cpd_callback_token', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_edge_service_instance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_edge_service_instance`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'ibm_cpd_transaction_id' in params:
            header_params['IBM-CPD-Transaction-ID'] = params['ibm_cpd_transaction_id']  # noqa: E501
        if 'ibm_cpd_callback_token' in params:
            header_params['IBM-CPD-Callback-Token'] = params['ibm_cpd_callback_token']  # noqa: E501
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_instances/provision', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessPostResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
