# coding: utf-8

"""
    IBM CLOUD PAK FOR DATA

    This is the Public API for IBM Cloud Pak for Data  # noqa: E501

    OpenAPI spec version: Beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from icpd_core.api_client import ApiClient


class EdgeSystemsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_edge_system_status(self, **kwargs):  # noqa: E501
        """Get the status of an edge system  # noqa: E501

        This API gets the status of edge system and the services running there.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_edge_system_status(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services.
        :param str secret: zen-service-broker-secret
        :return: SuccessGetStatusResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_edge_system_status_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_edge_system_status_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_edge_system_status_with_http_info(self, **kwargs):  # noqa: E501
        """Get the status of an edge system  # noqa: E501

        This API gets the status of edge system and the services running there.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_edge_system_status_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services.
        :param str secret: zen-service-broker-secret
        :return: SuccessGetStatusResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization', 'secret']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_edge_system_status" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'secret' in params:
            header_params['secret'] = params['secret']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_systems/status', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessGetStatusResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def tether_edge_system(self, body, **kwargs):  # noqa: E501
        """Tether an edge system with the CPD hub  # noqa: E501

        This API tethers an edge system with the CPD hub.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.tether_edge_system(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TetherObj body: Misc information required to tether edge node to the hub (required)
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services.
        :param str secret: zen-service-broker-secret
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.tether_edge_system_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.tether_edge_system_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def tether_edge_system_with_http_info(self, body, **kwargs):  # noqa: E501
        """Tether an edge system with the CPD hub  # noqa: E501

        This API tethers an edge system with the CPD hub.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.tether_edge_system_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TetherObj body: Misc information required to tether edge node to the hub (required)
        :param str authorization: Bearer token that includes user's platform permission. Can be used to communicate with other CPD services.
        :param str secret: zen-service-broker-secret
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'authorization', 'secret']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method tether_edge_system" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `tether_edge_system`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'secret' in params:
            header_params['secret'] = params['secret']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/edge_systems', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
