# coding: utf-8

"""
    IBM CLOUD PAK FOR DATA

    This is the Public API for IBM Cloud Pak for Data  # noqa: E501

    OpenAPI spec version: Beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from icpd_core.api_client import ApiClient


class SecretsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_secret(self, secret_reference, **kwargs):  # noqa: E501
        """Delete secret from vault  # noqa: E501

        Mark secret as deleted or delete it entirely if requested  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_secret(secret_reference, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str secret_reference: unique value identifying the secret for the user and the vault it is stored in (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_secret_with_http_info(secret_reference, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_secret_with_http_info(secret_reference, **kwargs)  # noqa: E501
            return data

    def delete_secret_with_http_info(self, secret_reference, **kwargs):  # noqa: E501
        """Delete secret from vault  # noqa: E501

        Mark secret as deleted or delete it entirely if requested  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_secret_with_http_info(secret_reference, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str secret_reference: unique value identifying the secret for the user and the vault it is stored in (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['secret_reference', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_secret" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'secret_reference' is set
        if ('secret_reference' not in params or
                params['secret_reference'] is None):
            raise ValueError("Missing the required parameter `secret_reference` when calling `delete_secret`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'secret_reference' in params:
            path_params['secret_reference'] = params['secret_reference']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/secrets/{secret_reference}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_secret(self, secret_reference, **kwargs):  # noqa: E501
        """Retrieve a specific secret from vault  # noqa: E501

        Retrieve secret from the vault by secret reference  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_secret(secret_reference, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str secret_reference: unique value identifying the secret for the user and the vault it is stored in (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessGetResponseV2
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_secret_with_http_info(secret_reference, **kwargs)  # noqa: E501
        else:
            (data) = self.get_secret_with_http_info(secret_reference, **kwargs)  # noqa: E501
            return data

    def get_secret_with_http_info(self, secret_reference, **kwargs):  # noqa: E501
        """Retrieve a specific secret from vault  # noqa: E501

        Retrieve secret from the vault by secret reference  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_secret_with_http_info(secret_reference, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str secret_reference: unique value identifying the secret for the user and the vault it is stored in (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessGetResponseV2
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['secret_reference', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_secret" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'secret_reference' is set
        if ('secret_reference' not in params or
                params['secret_reference'] is None):
            raise ValueError("Missing the required parameter `secret_reference` when calling `get_secret`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'secret_reference' in params:
            path_params['secret_reference'] = params['secret_reference']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/secrets/{secret_reference}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessGetResponseV2',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def patch_secret(self, secret_reference, body, **kwargs):  # noqa: E501
        """Update or refresh stored secret  # noqa: E501

        Update previously secured sensitive information  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_secret(secret_reference, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str secret_reference: unique value identifying the secret for the user and the vault it is stored in (required)
        :param PatchSecretPayload body: Updated sensitive payload to be secured (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_secret_with_http_info(secret_reference, body, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_secret_with_http_info(secret_reference, body, **kwargs)  # noqa: E501
            return data

    def patch_secret_with_http_info(self, secret_reference, body, **kwargs):  # noqa: E501
        """Update or refresh stored secret  # noqa: E501

        Update previously secured sensitive information  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_secret_with_http_info(secret_reference, body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str secret_reference: unique value identifying the secret for the user and the vault it is stored in (required)
        :param PatchSecretPayload body: Updated sensitive payload to be secured (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['secret_reference', 'body', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_secret" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'secret_reference' is set
        if ('secret_reference' not in params or
                params['secret_reference'] is None):
            raise ValueError("Missing the required parameter `secret_reference` when calling `patch_secret`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_secret`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'secret_reference' in params:
            path_params['secret_reference'] = params['secret_reference']  # noqa: E501

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/secrets/{secret_reference}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_secret(self, body, **kwargs):  # noqa: E501
        """Store secret  # noqa: E501

        Secure user provided secret in the vault  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_secret(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PostSecretPayload body: Sensitive payload to be secured (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_secret_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.post_secret_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def post_secret_with_http_info(self, body, **kwargs):  # noqa: E501
        """Store secret  # noqa: E501

        Secure user provided secret in the vault  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_secret_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PostSecretPayload body: Sensitive payload to be secured (required)
        :param str jwt_auth_user_payload: Supplied by proxy - do NOT add your own value
        :param str authorization: Bearer token based authentication
        :return: SuccessPostResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'jwt_auth_user_payload', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_secret" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `post_secret`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'jwt_auth_user_payload' in params:
            header_params['jwt-auth-user-payload'] = params['jwt_auth_user_payload']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/secrets', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SuccessPostResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
