# coding: utf-8

"""
    IBM CLOUD PAK FOR DATA

    This is the Public API for IBM Cloud Pak for Data  # noqa: E501

    OpenAPI spec version: Beta
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class NewSecretRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'members': 'SecretMembers',
        'secret': 'object',
        'secret_name': 'str',
        'type': 'str',
        'vault_urn': 'str'
    }

    attribute_map = {
        'description': 'description',
        'members': 'members',
        'secret': 'secret',
        'secret_name': 'secret_name',
        'type': 'type',
        'vault_urn': 'vault_urn'
    }

    def __init__(self, description=None, members=None, secret=None, secret_name=None, type='generic', vault_urn='0000000000:internal'):  # noqa: E501
        """NewSecretRequest - a model defined in Swagger"""  # noqa: E501

        self._description = None
        self._members = None
        self._secret = None
        self._secret_name = None
        self._type = None
        self._vault_urn = None
        self.discriminator = None

        if description is not None:
            self.description = description
        if members is not None:
            self.members = members
        self.secret = secret
        self.secret_name = secret_name
        if type is not None:
            self.type = type
        self.vault_urn = vault_urn

    @property
    def description(self):
        """Gets the description of this NewSecretRequest.  # noqa: E501

        short description about the secret being stored  # noqa: E501

        :return: The description of this NewSecretRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NewSecretRequest.

        short description about the secret being stored  # noqa: E501

        :param description: The description of this NewSecretRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def members(self):
        """Gets the members of this NewSecretRequest.  # noqa: E501


        :return: The members of this NewSecretRequest.  # noqa: E501
        :rtype: SecretMembers
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this NewSecretRequest.


        :param members: The members of this NewSecretRequest.  # noqa: E501
        :type: SecretMembers
        """

        self._members = members

    @property
    def secret(self):
        """Gets the secret of this NewSecretRequest.  # noqa: E501

        free-form object containing the secret or secret reference  # noqa: E501

        :return: The secret of this NewSecretRequest.  # noqa: E501
        :rtype: object
        """
        return self._secret

    @secret.setter
    def secret(self, secret):
        """Sets the secret of this NewSecretRequest.

        free-form object containing the secret or secret reference  # noqa: E501

        :param secret: The secret of this NewSecretRequest.  # noqa: E501
        :type: object
        """
        if secret is None:
            raise ValueError("Invalid value for `secret`, must not be `None`")  # noqa: E501

        self._secret = secret

    @property
    def secret_name(self):
        """Gets the secret_name of this NewSecretRequest.  # noqa: E501

        name of the secret  # noqa: E501

        :return: The secret_name of this NewSecretRequest.  # noqa: E501
        :rtype: str
        """
        return self._secret_name

    @secret_name.setter
    def secret_name(self, secret_name):
        """Sets the secret_name of this NewSecretRequest.

        name of the secret  # noqa: E501

        :param secret_name: The secret_name of this NewSecretRequest.  # noqa: E501
        :type: str
        """
        if secret_name is None:
            raise ValueError("Invalid value for `secret_name`, must not be `None`")  # noqa: E501

        self._secret_name = secret_name

    @property
    def type(self):
        """Gets the type of this NewSecretRequest.  # noqa: E501

        type of the secret  # noqa: E501

        :return: The type of this NewSecretRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this NewSecretRequest.

        type of the secret  # noqa: E501

        :param type: The type of this NewSecretRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["certificate", "credentials", "generic", "key", "token", "kerberos_credentials"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def vault_urn(self):
        """Gets the vault_urn of this NewSecretRequest.  # noqa: E501

        ID of user vault  # noqa: E501

        :return: The vault_urn of this NewSecretRequest.  # noqa: E501
        :rtype: str
        """
        return self._vault_urn

    @vault_urn.setter
    def vault_urn(self, vault_urn):
        """Sets the vault_urn of this NewSecretRequest.

        ID of user vault  # noqa: E501

        :param vault_urn: The vault_urn of this NewSecretRequest.  # noqa: E501
        :type: str
        """
        if vault_urn is None:
            raise ValueError("Invalid value for `vault_urn`, must not be `None`")  # noqa: E501

        self._vault_urn = vault_urn

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NewSecretRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NewSecretRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
